// figura.cpp - Ispitivanje klasa za geometrijske figure.

#include "krug.h"
#include "kvadrat.h"
#include "trougao.h"
#include <iostream>
using namespace std;

int main () {

  // Element liste figura.
  struct Elem {
    Figura* fig; Elem* sled;
    Elem (Figura* ff, Elem* ss=0) { fig = ff; sled = ss; }
    ~Elem () { delete fig; }
  };

  // Stvaranje liste figura citajuci preko glavnog ulaza.
  Elem *prvi = 0, *posl = 0;
  while (true) {
    Figura* pf = 0;
    char vrsta; cin >> vrsta;
    switch (vrsta) {
      case 'o': pf = new Krug;    break;
      case 'k': pf = new Kvadrat; break;
      case 't': pf = new Trougao; break;
    }
  if (!pf) break;
    cin >> *pf;
    Elem* novi = new Elem (pf);
    posl = (!prvi ? prvi : posl->sled) = novi;
  }

  // Prikazivanje sadrzaja liste na glavnom izlazu.
  for (Elem* tek=prvi; tek; tek=tek->sled) cout << *tek->fig << endl;

  // Unistavanje liste.
  while (prvi) { Elem* stari=prvi; prvi=prvi->sled; delete stari; }
  posl = 0;

  return 0;
}
